; example1.nsi
;
; This script is perhaps one of the simplest NSIs you can make. All of the
; optional settings are left to their default settings. The installer simply 
; prompts the user asking them where to install, and drops a copy of example1.nsi
; there. 

;--------------------------------

!include "LogicLib.nsh"
!include "dotNET.nsh"
!define DOTNET_VERSION "2.0"
!define SMNAME "Media Feed Screen Saver"
!define FNAME "MediaFeedScreenSaver.scr"
!define OUTPUTDIR "..\bin\Release\"

; The name of the installer
Name "Media Feed Screen Saver"

; The file to write
OutFile "MediaFeedScreenSaver_Installer.exe"

; The default installation directory
InstallDir "$PROGRAMFILES\Media Feed Screen Saver"

; Set compression
SetCompressor /solid lzma

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "Main Section (required)" ;No components page, name is not important

  SectionIn RO
 
  !insertmacro CheckDotNET

  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  WriteUninstaller "uninstall.exe"
  
  SetOutPath $WINDIR
  ; Put file there
  File ${OUTPUTDIR}${FNAME}
  ; File ${OUTPUTDIR}${FNAME}.config
  
SectionEnd ; end the section

; Optional section (can be disabled by the user)
Section "Create Start Menu shortcuts"

  CreateDirectory "$SMPROGRAMS\${SMNAME}"
  CreateShortCut "$SMPROGRAMS\${SMNAME}\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\${SMNAME}\Show Settings.lnk" "cmd.exe" '/c start "" "$WINDIR\${FNAME}"' "$WINDIR\${FNAME}" 0
  CreateShortCut "$SMPROGRAMS\${SMNAME}\Show Display Properties.lnk" "Rundll32.exe" 'shell32.dll,Control_RunDLL Desk.cpl,@0,1' "$WINDIR\${FNAME}" 0
  CreateShortCut "$SMPROGRAMS\${SMNAME}\Show Display Properties.lnk" "Rundll32.exe" 'shell32.dll,Control_RunDLL Desk.cpl,@0,1' "$WINDIR\${FNAME}" 0
  WriteINIStr "$SMPROGRAMS\${SMNAME}\${SMNAME} website.url" "InternetShortcut" "URL" "http://blog.debin.net/Media-feed-screen-saver/"
  
SectionEnd

Section "Select this screen saver as default"

        Exec 'DESK.CPL,InstallScreenSaver $WINDIR\${FNAME}'
        
SectionEnd

Section /o "Show Media Feed Screen Saver settings"

        Exec 'cmd.exe /c start "" "$WINDIR\${FNAME}"'
        
SectionEnd

Section "Uninstall"

  Delete "$SMPROGRAMS\${SMNAME}\*.*"
  RMDir "$SMPROGRAMS\${SMNAME}"

  Delete "$WINDIR\${FNAME}"
  Delete "$WINDIR\${FNAME}.config"

  Delete "$INSTDIR\uninstall.exe"

  RMDir "$INSTDIR"

SectionEnd
